var IAP_debug = false;
var IAP_activated = (ACTIVE_IAP_CSV == 1)? true : false;
var IAP_ready = false;
var IAP_app = {};
var buyableProducts = {"unlock_all_weapons":"buyable"};

IAP_app.initialize = function() {
	if(IAP_debug) console.log('initialize');
	document.addEventListener('deviceready', this.bind(this.onDeviceReady), false);
};
IAP_app.onDeviceReady = function() {
	if(IAP_debug) console.log('onDeviceReady');
	this.initStore();
};

IAP_app.initStore = function() {
	if (typeof(window.store) == "undefined" || !IAP_activated) {
		if(IAP_debug) console.log('Store not available');
		return;
	}
	//store.verbosity = store.DEBUG;
	
	if(IAP_debug) console.log('registerProducts');
	store.register({
		id:    'unlock_all_weapons', // id without package name!
		alias: 'unlock_all_weapons',
		type:   store.NON_CONSUMABLE
    });
	store.when("unlock_all_weapons").approved(function (order) {
		if(IAP_debug) console.log('You just unlocked the unlock_all_weapons!', order);
		order.finish();
		buyableProducts["unlock_all_weapons"] = "owned";
		IAP_GET_unlock_all_weapons();
		if(typeof(window.analytics) != 'undefined')	 window.analytics.trackEvent('buy', "unlock_all_weapons", 'done');
	});
	store.when("unlock_all_weapons").updated(function (product) {
		if(IAP_debug) console.log('You have the unlock_all_weapons!', product);
		if(product.owned){
			IAP_GET_unlock_all_weapons();
			buyableProducts["unlock_all_weapons"] = "owned";
		}
	});
	store.ready(function() {
		IAP_ready = true;
	});
	if(IAP_debug) console.log('refresh');
	store.refresh();
}

IAP_app.bind = function(fn) {
    return function() {
        fn.call(IAP_app, arguments);
    };
};

function IAP_C2CallbakDispatcher(cb, params, ack){
	if(typeof(cb) == "undefined") cb = "";
	if(cb == "") return false;
	if(typeof(ack) != "boolean") ack = true;
	
	if(typeof(params) == "undefined") params = [];
	if(params == null) params = [];
	if(typeof(params.join) != "function"){//is array
		params = [params];
	}
	
	if(typeof(c2_callFunction) != "function"){
		if(ack){
			setTimeout(IAP_C2CallbaksDispatcher, 100, cb, params, ack);
			return true;
		}else{
			return false;
		}
	}
	if(IAP_debug) console.log("C2 Call : ", arguments);
	return c2_callFunction(cb, params);
}

function IAP_buy(productToBuy, C2_successCb, C2_failCb){
	if(!IAP_ready) return false;
	if(typeof(productToBuy) == "undefined") productToBuy = "";
	if(typeof(C2_successCb) == "undefined") C2_successCb = "";
	if(typeof(C2_failCb) == "undefined") C2_failCb = "";
	if(productToBuy != "unlock_all_weapons"){
		IAP_C2CallbakDispatcher(C2_failCb, [0], false);
		return false;
	}
	if(typeof(window.analytics) != 'undefined')	 window.analytics.trackEvent('buy', productToBuy, 'initiated');
	var theOrder = store.order("unlock_all_weapons")
			.then(function(){
					IAP_C2CallbakDispatcher(this.C2_successCb, [1], false);
				}.bind(
						{C2_successCb:C2_successCb}
					)
			)
			.error(function(){
				IAP_C2CallbakDispatcher(this.C2_failCb, [0], false);}.bind({C2_failCb:C2_failCb})
			);
}

function IAP_isReady(product){
	if(!IAP_ready) return "0";
	//if no product specified, just reply if the store is ready
	if(typeof(product) == "undefined") return (IAP_ready) ? "1": "0";
	if(product == "") return (IAP_ready) ? "1": "0";
	if(typeof(buyableProducts[product]) == "undefined") return "0";
	if(buyableProducts[product] != "buyable") return "0";
	try{
		JSON.parse(c2_callFunction('getGameInfo',[])).gameName;
	}catch(e){
		 return "0";
	}
	return "1";
}

/*
if(typeof(setCookie) == "undefined"){
	var setCookie = function(cname, cvalue, exdays) {
		var d = new Date();
		d.setTime(d.getTime() + (exdays*24*60*60*1000));
		var expires = "expires="+d.toUTCString();
		document.cookie = cname + "=" + cvalue + "; " + expires;
	};
}
// if(typeof(getCookie) == "undefined"){
	var getCookie = function(cname, defaultVal) {
		if(typeof(defaultVal) == "undefined") defaultVal = "";
		var name = cname + "=";
		var ca = document.cookie.split(';');
		for(var i=0; i<ca.length; i++) {
			var c = ca[i];
			while (c.charAt(0)==' ') c = c.substring(1);
			if (c.indexOf(name) == 0) return c.substring(name.length,c.length);
		}
		return defaultVal;
	};
// }

if(typeof(getLocalStorageItem) == "undefined"){
	var getLocalStorageItem = function (item, defaultVal){
		if(typeof(defaultVal) == "undefined") defaultVal = "";
		if(typeof(localStorage) == "undefined") return defaultVal;
		var tmpVal = localStorage.getItem(item);
		if(tmpVal == null) return defaultVal;
		return tmpVal;
	}
}

if(typeof(getSaveSRC) == "undefined"){
	var getSaveSRC = function(){
		var toRet = "cookie";
		if(typeof(localStorage) != "undefined"){
			localStorage.setItem('testWriteCordova', 'test');
			if(localStorage.getItem('testWriteCordova') == 'test') toRet = "local";
		}
		return toRet;
	};
}
*/

function refreshShop(){
	IAP_C2CallbakDispatcher("loadSavedStashOrDefaultAfterLoadShopManager", [], true);
	IAP_C2CallbakDispatcher("updateShopGUI", [], true);
}


function IAP_servingGift(){
	if(getSaveSRC() == "local"){
		localStorage.setItem(JSON.parse(c2_callFunction('getGameInfo',[])).gameName + 'Stash', JSON.stringify(window.newStash));
		//localStorage.setItem('stickmanFighterEB_GCODEStash', JSON.stringify(window.newStash));
	}else{
		setLocalStorageItem(JSON.parse(c2_callFunction('getGameInfo',[])).gameName + 'Stash', JSON.stringify(window.newStash));
		//setCookie('stickmanFighterEB_GCODEStash', JSON.stringify(window.newStash), 365);
	}
	if(IAP_debug) console.log("applying : ", JSON.stringify(window.newStash));
	refreshShop();
}

function prepare_unlock_all_weapons_poor(){
	if(typeof(window.newStash.stash.items.hadou) == "undefined"){	window.newStash.stash.items.hadou = {"unlocked":1,"quantity":4};	}else{	window.newStash.stash.items.hadou.unlocked = 1;	window.newStash.stash.items.hadou.quantity = 4;	}
	if(typeof(window.newStash.stash.items.life) == "undefined"){	window.newStash.stash.items.life = {"unlocked":1,"quantity":4};	}else{	window.newStash.stash.items.life.unlocked = 1;	window.newStash.stash.items.life.quantity = 4;	}
	for(var weaponNb = 0; weaponNb < 12; weaponNb++){
		if(typeof(window.newStash.stash['weapon_' + weaponNb]) == "undefined"){
			window.newStash.stash.items['weapon_' + weaponNb] = {};
		}
		window.newStash.stash.items['weapon_' + weaponNb]['unlocked'] = 1;
		window.newStash.stash.items['weapon_' + weaponNb]['quantity'] = 6;
	}
}

function IAP_GET_unlock_all_weapons(){
	if(IAP_debug) console.log('Unlocking every weapons!');
	//{"stash":{"items":{"weapon_0":{"unlocked":1,"quantity":4},"weapon_1":{"unlocked":1,"quantity":4},"weapon_2":{"unlocked":1,"quantity":4},"weapon_3":{"unlocked":1,"quantity":4},"weapon_4":{"unlocked":1,"quantity":4},"weapon_5":{"unlocked":1,"quantity":4},"weapon_6":{"unlocked":1,"quantity":4},"weapon_7":{"unlocked":1,"quantity":4},"weapon_8":{"unlocked":1,"quantity":4},"weapon_9":{"unlocked":1,"quantity":4},"weapon_10":{"unlocked":1,"quantity":4},"weapon_11":{"unlocked":1,"quantity":4},"life":{"unlocked":1,"quantity":4},"hadou":{"unlocked":1,"quantity":4}},"money":{"normal":{"gold":8616,"silver":0,"bronze":0},"premium":{"gold":0}}}}
	//get stash
	var defaultStash = "error";
	if(typeof(playtouch) != "undefined"){
		if(typeof(playtouch.shopManager) != "undefined"){
			if(typeof(playtouch.shopManager.getBaseStash) != "undefined") defaultStash = playtouch.shopManager.getBaseStash();
		}
	}
	if(defaultStash == "error"){
		if(typeof(shopManager) != "undefined"){
			if(typeof(shopManager.getBaseStash) != "undefined") var defaultStash = shopManager.getBaseStash();
		}
	}
	var IAM_gameName = JSON.parse(c2_callFunction('getGameInfo',[])).gameName;
	var currentStash = getLocalStorageItem(IAM_gameName + 'Stash', false) || defaultStash;
	if(currentStash == "error"){
		setTimeout(IAP_GET_unlock_all_weapons, 200);
		return false;
	}
	if(typeof(currentStash) == "string"){
		try{
			window.newStash = JSON.parse(currentStash);
		}catch(e){
			return false;
		}
	}else{
		window.newStash = currentStash;
	}
	if(typeof(window.newStash) == "undefined"){	setTimeout(IAP_GET_unlock_all_weapons, 200);	return false;	}
	if(typeof(window.newStash.stash) == "undefined"){	setTimeout(IAP_GET_unlock_all_weapons, 200);	return false;	}
	if(typeof(window.newStash.stash.items) == "undefined"){	setTimeout(IAP_GET_unlock_all_weapons, 200);	return false;	}

	
	if(typeof(jQuery) == "undefined"){
		setTimeout(IAP_GET_unlock_all_weapons, 200);
		return false;
	}
	$.ajax({
		  url: "shop.json",
		  dataType: "json"
		}).done(function(data) {
			var shopsObject = data;
			if(typeof(shopsObject) == "string"){
				try{
					shopsObject = JSON.parse(data);
				}catch(e){
					prepare_unlock_all_weapons_poor();
				}
			}
			if(typeof(shopsObject.shop) == "undefined"){	prepare_unlock_all_weapons_poor();	return false;	}
			for(var anItem in shopsObject.shop){
				if(shopsObject.shop.hasOwnProperty(anItem)){
					if(typeof(shopsObject.shop[anItem].quantityMax) != "undefined"){
						if(typeof(window.newStash.stash.items[anItem]) == "undefined"){
							window.newStash.stash.items[anItem] = {};
						}
						window.newStash.stash.items[anItem].unlocked = 1;
						window.newStash.stash.items[anItem].quantity = shopsObject.shop[anItem].quantityMax;
					}
				}
			}
			IAP_servingGift();
		}).fail(function(){
			prepare_unlock_all_weapons_poor();
			IAP_servingGift();
		});
	return true;
}

IAP_app.initialize();